
data names;
input @;
_infile_ = upcase(_infile_);
input name :$10. age city :$10. state :$2.;
datalines;
mike 25 albany ny
Sara 15 Washington DC
;

%p(names)

data names;
infile datalines dsd dlm='/';
input name :$10. age city :$10. state :$2.;
datalines;
MIKE//25////NY
SARA//15//WASHINGTON//DC
JESSICA/9////CA
;

%p(names)

data names;
infile datalines dsd dlm='/';
input @;
_infile_ = tranwrd(_infile_,'//','/');
input name :$10. age city :$10. state :$2.;
datalines;
MIKE//25////NY
SARA//15//WASHINGTON//DC
JESSICA/9////CA
;

%p(names)

* example 1;
proc means data=sashelp.class maxdec=2 median;
where sex eq 'M';
run;

proc format;
value ag low-<13.5 = '0' other = '1';
value ht low-<64.15 = '0' other = '1';
value wt low-<107.25 = '0' other = '1';
run;

filename nosee dummy;

data males (drop=sex);
file nosee;
set sashelp.class (where=(sex eq 'M'));
put age ag. height ht. weight wt. @;
aghtwt = _file_;
put;
run;

%p(males)

%c(males)

data males (drop=sex);
length aghtwt $3;
file nosee;
set sashelp.class (where=(sex eq 'M'));
put age ag. height ht. weight wt. @;
aghtwt = _file_;
put;
run;

%c(males)

data males (drop=sex);
length aghtwt $3;
file nosee;
set sashelp.class (where=(sex eq 'M'));
put age ag. height ht. weight wt. @;
aghtwt = _file_;
run;

%p(males)

data males (drop=sex);
length aghtwt $3;
set sashelp.class (where=(sex eq 'M'));
put @1 age ag. height ht. weight wt. @;
aghtwt = _file_;
run;

%p(males)

* example 1;
data answers;
input id : $5. (q1-q10) (: $1.);
datalines;
A1234 Y Y Y Y Y Y Y Y N N
A2345 N N N N N N N N N N
A3456 N N N N N N N N N Y
A4567 N N N N Y N N N N N
A5678 Y N N Y N N Y N N Y
;
run;

%p(answers)

data atleast1y_catt;
set answers;
if find(catt(of q:),'Y');
run;

%p(atleast1y_catt)

data atleatst1y_whichc;
set answers;
if whichc('Y', of q:);
run;

%p(atleast1y_whichc)

data atleats1y_in_array;
set answers;
array q(10);
if 'Y' in q;
run;

%p(atleast1y_in_array)


* example 2;
data diagnoses;
infile datalines truncover;
input id :$2. (dx1-dx5) (:$5.);
datalines;
01 486      5849     5990     04104    45119
02 5589     27651    5990     78079
03 51881    49121    V1582    V1251    78650
04 5781     V1042    V1041    25060    25050
05 496      4280     25040    58281    5859
06 486      496      340      311
;

%p(diagnoses)

data diabetes (drop=j);
set diagnoses;
array dx(5);
do j=1 to 5 until (dx(j) eq: '250');
end;
if j lt 6;
run;

%p(diabetes)

data diabetes;
set diagnoses;
array dx(5);
if '250' in : dx;
run;

%p(diabetes)

data diagnoses;
set diagnoses;
array dx(5);
diabetes = '250' in : dx;
asthma   = '493' in : dx;
run;

%p(diagnoses)

data diagnoses;
infile datalines missover;
input id :$2. (dx1-dx5) (:$5.);
datalines;
01 95901    78039    4280     87342    81612
02 78039    41400    4019     85301
03 82009    30501    496      2875     41400
04 9949     2765     4280     4240     78039
05 8730     9120     80001
;

%p(diagnoses)

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ;
run;

data tbi;
set diagnoses;
put @1 (dx1-dx5) ($tbi.) @;
if find(_file_,'1');
run;

%p(tbi)

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ' ' ='x';
run;

data tbi;
set diagnoses;
length tbi $5;
put @1 (dx1-dx5) ($tbi.) @;
if find(_file_,'1');
tbi = _file_;
run;

%p(tbi)

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ' ' = ' ';
run;

data tbi (drop=j);
set diagnoses;
array dx(5);
array tbi(5);
do j=1 to 5;
   tbi(j) = input(put(dx(j),$tbi.),1.);
end;
run;

%p(tbi)

data tbi;
if _n_ eq 1 then input @;
set diagnoses;
put @1 (dx1-dx5) ($tbi.) @;
_infile_ = _file_;
input @1 (tbi1-tbi5) (1.) @@;
datalines;
*
;

%p(tbi)

data char_num;
input (id sex) (:$1.) a b c d e @@;
cards;
1 M 1 2 3 4 5 2 F 9 9 9 9 9 3 M 8 8 8 8 8 1 M 1 2 3 4 5
2 F 9 9 9 9 9 3 M 8 8 8 8 8 3 M 8 8 8 8 8 4 Q 9 9 9 9 9
;

%p(char_num)

%c(char_num)

data char (drop=_numeric_);
set char_num;
array old(5) a b c d e;
array x(5) $1;
do j=1 to 5;
   x(j) = put(old(j),1.);
end;
run;

%p(char)

%c(char);

data new;
if _n_ eq 1 then input @;
set char_num;
put @1 (_numeric_) (:) @ ;
_infile_ = _file_;
input @1 (x1-x5) (:$1.) @@;
drop a--e;
datalines;
*
;

%c(new)

%p(new)

data with_missing;
input name : $10. gender : $1. age height weight;
datalines;
MIKE M 21 60 .
MARY F 0  .  .
MARK . 45 72 0
;

%p(with_missing)

data no_missing;
length missing $3;
set with_missing;
array nm(*) _numeric_;
do _n_=1 to dim(nm);
   missing = catt(missing,missing(nm(_n_)));
   nm(_n_) + 0;
end;
run;

%p(no_missing)

data with_missing;
input name : $10. gender : $1. age height weight;
datalines;
MIKE M 21 60 .
MARY F 0  .  .
MARK . 45 72 0
;

proc format;
value fix low-high='0' other='1';
run;

data with_missing;
length missing $3;
set with_missing;
put @1 (_numeric_) (fix.) @;
missing = _file_;
run;

proc stdize data=with_missing out=no_missing reponly missing=0;
run;

%p(no_missing)


data with_missing;
input name : $10. gender : $1. age height weight;
datalines;
MIKE M 21 60 .
MARY F 0  .  .
MARK . 45 72 0
;

proc format;
value fix low-high='0' other='1';
run;

filename nosee dummy
data with_missing;
length missing $3;
set with_missing;
put @1 (_numeric_) (fix.) @;
missing = _file_;
run;






















data with_missing;
set sashelp.class;
if ranuni(999) le .5;
if ranuni(999) le .2 then
call missing(weight,age);
run;


%p(with_missing)



data with_missing;
length missing $3;
set with_missing;
put @1 (_numeric_) (fix.) @;
missing = _file_;
run;


%p(with_missing)


proc stdize data=with_missing out=no_missing reponly missing=median;
run;

%p(no_missing)




data have;
input ptno day event @@;
cards;
1 1 0 1 1 0 1 1 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 2 0 1 2 0 1 2 0 1 2 0 1 2 0 1 2 0 1 2 0 1 2 0
2 1 0 2 1 0 2 1 0 2 1 1 2 1 1 2 1 1 2 1 0 2 1 0
2 2 0 2 2 1 2 2 1 2 2 0 2 2 1 2 2 0 2 2 0 2 2 0
2 2 1 2 2 0
;


data want;
do until (last.event);
 set have;
 by ptno day event notsorted;
 if first.event then do;
    put (ptno day event) (3*1. '*') @;
    npattern = count(_file_,catt(ptno,day,event));
 end;
 output;
end;
run;

%p(want)

filename nosee dummy;

data _null_;
set sashelp.zipcode (obs=1);
call missing(of _all_);
put @1 (_numeric_ ) (= ',') @;
call symput('nm',compress(substr(_file_,2),",_","kda"));
put;
put @1 (_character_ ) (= ',') @;
call symput('ch',compress(substr(_file_,2),",_","kda"));
run;


%put &nm;
%put &ch;


data names;
input @;
_infile_ = upcase(_infile_);
input name :$10. age city :$10. state :$2.;
datalines;
mike 25 albany ny
Sara 15 Washington DC
;

%p(names)

data names;
infile datalines dlm='/';
input name :$10. age city :$10. state :$2.;
datalines;
MIKE//25////NY
SARA//15//WASHINGTON//DC
JESSICA/9////CA
;

%p(names)

data newnames;
infile datalines dsd dlm='/';
input @;
_infile_ = tranwrd(_infile_,'//','/');
put _infile_;
input name :$10. age city :$10. state :$2.;
datalines;
MIKE//25////NY
SARA//15//WASHINGTON//DC
JESSICA/9////CA
;


%p(newnames)


proc means data=sashelp.class median;
where sex eq 'M';
run;

proc format;
value ag low-<13.5  = '0'   other = '1';
value ht low-<64.15 = '0'   other = '1';
value wt low-<107.25 = '0'  other = '1';
run;

filename nosee dummy;

data males (drop=sex);
file nosee;
set sashelp.class (where=(sex eq 'M'));
put age ag. height ht. weight wt. @;
htwt = _file_;
run;

%p(males)

data males (drop=sex);
set sashelp.class (where=(sex eq 'M'));
put @1 age ag. height ht. weight wt. @;
htwt = _file_;
run;

%p(males)

